#
__version__ = '$Id: config.py,v 1.19 2021/09/14 14:44:10 schreurs Exp $'
#
# Configurable GUI parameters (like colors)
#
# (C) 1997--2004 Rob W.W. Hooft, Bruker AXS BV
#
# Gui appearance
i_am_a_developer=0
anyexpert=0
bgpossible='springgreen2'
bgpossiblehigh='springgreen1'
bgimpossible='indianred2'
bgimpossiblehigh='indianred1'
bgtodo='indianred2'
bgtodohigh='indianred1'
bgdone='springgreen2'
bgdonehigh='springgreen1'
bgok='springgreen2'
bgwarning='yellow2'
bgerror='indianred2'
bgbusy='yellow2'
bgframe='grey60'
bgcolors=["grey85","#DFF","#DDF","#FDF","#FDD","#FFD","#DFD"]
adcfilter=1
anglemargin=1.5
autochiralpointgroup=0
autodark=True
autostartserver=1
axcrit=0.2
backgroundradius=0
beamcatcheraccuracy=0.2
beamcatcherbladethickness=0.5
beamcatchercrystalsize=None
beamcatcherdiameter=None
beamcatcherdistance=None
beamcatcherheaderreliable=1
boxcompress=''
cellaskkcdfilename=0
cellrefinedetector=0
chiralonly=0
crashinvalidhkl=1
csdaxiscrit=0.015
darkfilter=1
datcoldx=35
defaultwavelength=0.71073
detectorsizemargin=1.5
dirax_installed=True
dirax_program="dirax"
dxlimit=300
eval14_installed=True
eval14_program='../ccd/evalccd/evalccd'
eval15_installed=True
eval15_program='../ccd/pixel15/eval15'
evalalldmm=0.1
evalalldrot=0.1
eventlogfile="evpy.log"
fixedfont='Typewriter'
focusdistance=220
focussize=0.4
fontscheme='pmw1'
fontsize=12
hashfilepattern='##f####.kcd'
iconifyevalmessages=False
imageextension='.kcd'
inhibitgc=1
initialballoonhelp=0
interactlog='interact.log'
kcddatatype=None
localcifdata=''
localdarkfilter=1
logicalfont='Courier'
mailrecipient='ccd'
manualhkllimits=0
maxfocussize=1.0
maximumhighresolution=2.0
maxboxdepth=19
mindiskspace=1000000
minimumlowresolution=4.0
minscanserieslength=5
mouserotspeed=0.01
mousescalefactor=1.003
ndisppeakfiletool=0
ndispmousemirrortool=0
nprintformats=['ps','ppm','png','jpg']
nominalpowerfraction=0.9
nominalvoltage={'MO':60,'CU':45,'AG':60}
nottooclose=0
packettimeout=30
peakbackgroundmargin=1
peakradiusfactor=2.2
peakrefexpert=0
peaksizefraction=0.7
phichiindexfit=2
phichiintcrit=0.5
phichilevelfit=1000
phichiradcrit=0.16
platon_installed=False
preferpostref=False
progressfile=''
psviewers=["kghostview","gv","ghostview"]
readoutnoise=3.0
reportsquarer=0
resolution=0.77
resomode=0
rpclogfile='/dev/null'
sadabs_installed=True
sadabs_program="../sadabs/sadabs"
sadabs_terminal=["xterm","-e"]
scalemerge=1
scalerestrain=0.002
scanrepr=1
scanwidthtolerance=0.003
boxdepth=5
boxsizemm=2.3
boxmakepreref=0
boxmakelow=0
shortdarkfilter=1
showtotalrefls=0
solve_installed=False
someplotbatch=10
spotradius=0
temperaturerampspeed=240
temperaturetolerance=0.5
twinabs_installed=True
twinabs_program="../twinabs/twinabs"
usepeakdb=1
viewposition={'phi':-74.66,'theta':0,'omega':105.340,'kappa':-46.224,'dx':-5}
weaklevel=10
webbrowsers=["firefox","icewease","mozilla","netscape"]
xtalbasedir=None
xtaldiameter=0.3
xtaloperators=[]
xtalsnapdir="xtalsnap"
xtalsnapformat=(".ppm","PPM")
xtalsnapinterval=60*60
# Backward compatibility
xdefault={}
# Functions that change parameters in groups
def default_protein():
    global resomode
    resomode=1
    global minscanserieslength
    minscanserieslength=2
#    global processtogether
#    processtogether=2
    global maximumhighresolution
    maximumhighresolution=8.0
    global resolution
    resolution=2.5
#    global indexdx
#    indexdx=60
#    global indexscanrange
#    indexscanrange=2.5
#    global indexframeangle
#    indexframeangle=0.5
#    global indexdegreetime
#    indexdegreetime=60
#    global completeness
#    completeness=0.98
    global chiralonly
    chiralonly=1
#    global resolutioncircleradius
#    resolutioncircleradius=(10,5,4,3,2)
#    global peaksearchthetamin
#    peaksearchthetamin=1.5
    global defaultwavelength
    defaultwavelength=1.541838
    global boxcompress
    boxcompress='.Z'
    
def default_noprotein():
    global resomode
    resomode=0
    global minscanserieslength
    minscanserieslength=2
#    global processtogether
#    processtogether=15
    global maximumhighresolution
    maximumhighresolution=2.0
    global resolution
    resolution=0.77
#    global indexdx
#    indexdx=40
#    global indexscanrange
#    indexscanrange=10
#    global indexframeangle
#    indexframeangle=1
#    global indexdegreetime
#    indexdegreetime=20
#    global completeness
#    completeness=0.995
    global chiralonly
    chiralonly=0
#    global resolutioncircleradius
#    resolutioncircleradius=(7.0,1.2,0.77,0,0)
#    global peaksearchthetamin
#    peaksearchthetamin=4
    global defaultwavelength
    defaultwavelength=0.71073
    
def default_eval():
    import sys
    global eval14_installed
    eval14_installed=True
    global dirax_installed
    dirax_installed=True
    global sadabs_installed
    sadabs_installed=(sys.platform[:5]=='linux')
    global superguidata
    superguidata='eval14'
    global superguiindex
    superguiindex='phichi'
    global dxfactor
    dxfactor=1.4
    global autodark
    autodark=True

# System-level and User-level changes.
# Store current variables and their types.
_glv={}
_glv.update(globals())
_gl=_glv.keys()
_tp={}
for _key in _gl:
    if _key[0]!='_':
        _tp[_key]=type(globals()[_key])
del _key
# Get the user files
import os

def _myexecfile(filename, globals=None, locals=None):
    import sys
    if globals is None:
        globals = sys._getframe(1).f_globals
    if locals is None:
        locals = sys._getframe(1).f_locals
    with open(filename, "r") as fh:
        exec(fh.read()+"\n", globals, locals)
                                                    
for _filename in ["/usr/local/lib/evpy-config.py",
                  os.environ["HOME"]+"/.evpy-config",
                  "evpy-config"]:
    if os.path.exists(_filename):
        _filestatus=os.stat(_filename)
        _filemode=_filestatus[0]
        _fileuid=_filestatus[4]
        # print("execfile '%s'"%_filename)
        if (_fileuid==os.getuid() or _fileuid==0):
            if _filemode&0o002==0:
                # execfile(_filename) # python2
                with open(_filename, "rb") as _source_file:
                    _code = compile(_source_file.read(), _filename, "exec")
                    exec(_code)
                # del _source_file,_code
            else:
                print("WARNING: Skipped '%s': writeable by others."%_filename)
        else:
            print("WARNING: Skipped '%s': owned by someone else."%_filename)
        del _filemode,_fileuid,_filestatus
del os,_filename
# Test for obsoleted and/or unknown variables.
for _key in list(globals().keys()):
    if _key[0]=='_':
        pass
    elif _key in _gl:
        nt=type(globals()[_key])
        ot=_tp[_key]
        if nt==ot or nt==type(None) or ot==type(None):
            pass
        elif nt==type(1) and ot==type(1.0):
            pass
        elif ot==type(1) and nt==type(1.0):
            pass
        elif _key=='xtaloperators' and nt==type({}):
            pass
        else:
            print("WARNING: Type of '%s' changed"%_key)
            print("       Was: ",ot)
            print("       Now: ",nt)
        del nt,ot
    elif _key=='phichiframetime':
        phichiexposuretime=phichiframetime
        del phichiframetime
        print("WARNING: Please rename 'phichiframetime' to 'phichiexposuretime' in")
        print("         your configuration files")
    elif _key=='validinputbackground':
        bgpossible=validinputbackground
        del validinputbackground
        print("WARNING: Configuration variable 'validinputbackground' is now called 'bgpossible'")
        print("         please change your configuration files accordingly")
    elif _key=='brightvalidinputbackground':
        bgpossiblehigh=brightvalidinputbackground
        del brightvalidinputbackground
        print("WARNING: Configuration variable 'brightvalidinputbackground' is now called 'bgpossiblehigh'")
        print("         please change your configuration files accordingly")
    elif _key=='invalidinputbackground':
        bgimpossible=invalidinputbackground
        del invalidinputbackground
        print("WARNING: Configuration variable 'invalidinputbackground' is now called 'bgimpossible'")
        print("         please change your configuration files accordingly")
    elif _key=='brightinvalidinputbackground':
        bgimpossiblehigh=brightinvalidinputbackground
        del brightinvalidinputbackground
        print("WARNING: Configuration variable 'brightinvalidinputbackground' is now called 'bgimpossiblehigh'")
        print("         please change your configuration files accordingly")
    elif _key=='busybackground':
        bgbusy=busybackground
        del busybackground
        print("WARNING: Configuration variable 'busybackground' is now called 'bgbusy'")
        print("         please change your configuration files accordingly")
    elif _key=='framebackground':
        bgframe=framebackground
        del framebackground
        print("WARNING: Configuration variable 'framebackground' is now called 'bgframe'")
        print("         please change your configuration files accordingly")
    elif _key in ['userpc','view_program']:
        print("WARNING: Configuration variable '%s' obsolete"%_key)
        print("         please change your configuration files accordingly")
    else:
        print("WARNING: Configuration variable %s not known. Misspelled?"%_key)
del _key,_tp
#
# Empty the xdefault variable
#
if xdefault:
    print("WARNING: configuration variable 'xdefault' is deprecated.")
    print("         please check your configuration files, and replace:")
    for _key in xdefault.keys():
        if _key=='dx':
            _nv='datcoldx'
        else:
            _nv=_key
        s="           xdefault['%s']=%s"%(_key,repr(xdefault[_key]))
        a="%s=%s"%(_nv,repr(xdefault[_key]))
        s=s+" "*(45-len(s))+" by     "+a
        print(s)
        exec(a)
    del _nv,_key,s,a
del xdefault,_gl
#
# Remove the functions
#
del default_protein,default_eval

if __name__=="__main__":
    from misc import args
    _args=args
    del args
    _all=1
    for _arg in _args.ArgLoop():
        if _arg=="modified":
            _all=0
        else:
            _arg.unknown()
    _k=globals().keys()
    _k.sort()
    for _name in _k:
        if _name[0]!='_':
            if _all or _glv[_name]!=globals()[_name]:
                print(_name,"=",repr(globals()[_name]))

del _glv
